buffers.hpp File Reference
`#include <memory>`
`#include <array>`
`#include <string>`
`#include <cstring>`
`#include <type_traits>`
`#include <restinio/asio_include.hpp>`
`#include <restinio/exception.hpp>`
`#include <restinio/sendfile.hpp>`
`#include <restinio/compiler_features.hpp>`
`#include <restinio/utils/suppress_exceptions.hpp>`
`#include <restinio/utils/impl/safe_uint_truncate.hpp>`
`#include <restinio/impl/include_fmtlib.hpp>`

Go to the source code of this file.

## Classes

class | restinio::impl::writable_base_t
| A base class for writable items. More...
class | restinio::impl::buf_iface_t
| Internal interface for a trivial buffer-like entity. More...
class | restinio::impl::empty_buf_t
| Empty buffer entity. More...
class | restinio::impl::const_buf_t
| Buffer entity for const buffer. More...
class | restinio::impl::datasizeable_buf_t< Datasizeable >
| User defined datasizable object. More...
class | restinio::impl::shared_datasizeable_buf_t< Datasizeable >
| Buffer based on shared_ptr of data-sizeable entity. More...
struct | restinio::impl::sendfile_write_operation_t
| Send file operation wrapper. More...
struct | restinio::const_buffer_t
| Helper class for setting a constant buffer storage explicitly. More...
class | restinio::writable_item_t
| Class for storing the buffers used for streaming body (request/response). More...
class | restinio::write_group_t
| Group of writable items transported to the context of underlying connection as one solid piece. More...

## Namespaces

namespace | restinio
namespace | restinio::impl

## Typedefs

using | restinio::fmt_minimal_memory_buffer_t = fmt::basic_memory_buffer< char, 1u >
| An alias for fmt::basic_memory_buffer<char,1>. More...
using | restinio::impl::string_buf_t = datasizeable_buf_t< std::string >
| An alias for a std::string instantiation of datasizeable_buf_t<D> template. More...
using | restinio::impl::fmt_minimal_memory_buffer_buf_t = datasizeable_buf_t< fmt_minimal_memory_buffer_t >
| An alias for a fmt_minimal_memory_buffer_t instantiation of datasizeable_buf_t<D> template. More...
using | restinio::writable_items_container_t = std::vector< writable_item_t >
using | restinio::write_status_cb_t = std::function< void(const asio_ns::error_code &ec) >
| An alias for a callback to be invoked after the write operation of a particular group of "buffers". More...

## Enumerations

enum class | restinio::writable_item_type_t { restinio::trivial_write_operation , restinio::file_write_operation }
| Buffers write operation type. More...

## Functions

Create const buffers.
constexpr const_buffer_t | restinio::const_buffer (const void *str, std::size_t size) noexcept
const_buffer_t | restinio::const_buffer (const char *str) noexcept

## Variables

constexpr std::size_t | restinio::impl::buffer_storage_align
constexpr std::size_t | restinio::impl::needed_storage_max_size
| An of memory that is to be enough to hold any possible buffer entity. More...